#Embedded file name: e:\jenkins\workspace\client_SERENITY\branches\release\SERENITY\eve\client\script\ui\shared\neocom\corporation\corp_ui_standings.py
import uiprimitives
import uicontrols
import uiutil
import form
import listentry
import types
import carbonui.const as uiconst
import log
import localization

class CorpStandings(uiprimitives.Container):
    __guid__ = 'form.CorpStandings'
    __nonpersistvars__ = []
    __notifyevents__ = ['OnSetCorpStanding']

    def ApplyAttributes(self, attributes):
        uiprimitives.Container.ApplyAttributes(self, attributes)
        sm.RegisterNotify(self)

    def OnSetCorpStanding(self, *args):
        if uiutil.IsVisible(self) and self.sr.Get('inited', False) and self.sr.tabs:
            self.sr.tabs.ReloadVisible()

    def Load(self, args):
        if not self.sr.Get('inited', False):
            self.sr.inited = 1
            btns = None
            self.toolbarContainer = uiprimitives.Container(name='toolbarContainer', align=uiconst.TOBOTTOM, parent=self)
            if btns is not None:
                self.toolbarContainer.height = btns.height
            else:
                self.toolbarContainer.state = uiconst.UI_HIDDEN
            self.sr.contacts = form.ContactsForm(name='corpcontactsform', parent=self, pos=(0, 0, 0, 0))
            self.sr.contacts.Setup('corpcontact')
            self.sr.scroll = uicontrols.Scroll(name='standings', parent=self, padding=(const.defaultPadding,
             const.defaultPadding,
             const.defaultPadding,
             const.defaultPadding))
            self.sr.tabs = uicontrols.TabGroup(name='tabparent', parent=self, idx=0)
            self.sr.tabs.Startup([[localization.GetByLabel('UI/Corporations/CorporationWindow/Standings/CorpContacts'),
              self.sr.contacts,
              self,
              'corpcontact'], [localization.GetByLabel('UI/Corporations/CorporationWindow/Standings/LikedBy'),
              self.sr.scroll,
              self,
              'mystandings_to_positive'], [localization.GetByLabel('UI/Corporations/CorporationWindow/Standings/DislikedBy'),
              self.sr.scroll,
              self,
              'mystandings_to_negative']], 'corporationstandings', autoselecttab=1)
            return
        sm.GetService('corpui').LoadTop('res:/ui/Texture/WindowIcons/corporationstandings.png', localization.GetByLabel('UI/Corporations/CorporationWindow/Standings/CorpStandings'))
        self.SetHint()
        if type(args) == types.StringType and args.startswith('mystandings_'):
            self.sr.standingtype = args
            if args == 'mystandings_to_positive':
                positive = True
            else:
                positive = False
            self.ShowStandings(positive)
        else:
            self.sr.contacts.LoadContactsForm('corpcontact')

    def SetHint(self, hintstr = None):
        if self.sr.scroll:
            self.sr.scroll.ShowHint(hintstr)

    def ShowStandings(self, positive, *args):
        sm.GetService('corpui').ShowLoad()
        scrolllist = sm.GetService('standing').GetStandingEntries(positive, session.corpid)
        self.sr.scroll.Load(fixedEntryHeight=19, contentList=scrolllist)
        sm.GetService('corpui').HideLoad()


class CorporationOrAlliancePickerDailog(uicontrols.Window):
    __guid__ = 'form.CorporationOrAlliancePickerDailog'
    default_windowID = 'CorporationOrAlliancePickerDailog'
    default_iconNum = 'res:/ui/Texture/WindowIcons/corporation.png'

    def ApplyAttributes(self, attributes):
        uicontrols.Window.ApplyAttributes(self, attributes)
        warableEntitysOnly = attributes.warableEntitysOnly
        self.ownerID = None
        self.searchStr = ''
        self.searchAttr = attributes.Get('searchStr', '')
        self.warableEntitysOnly = warableEntitysOnly
        self.SetScope('all')
        self.Confirm = self.ValidateOK
        strTitle = localization.GetByLabel('UI/Corporations/CorporationWindow/Standings/SelectCorpOrAlliance')
        if self.warableEntitysOnly:
            strTitle = localization.GetByLabel('UI/Corporations/CorporationWindow/Standings/SelectWarableCorpOrAlliance')
        self.SetCaption(strTitle)
        self.SetMinSize([320, 300])
        if self.searchAttr:
            self.SetTopparentHeight(0)
        self.SetWndIcon(self.iconNum)
        self.sr.standardBtns = uicontrols.ButtonGroup(btns=[[localization.GetByLabel('UI/Generic/OK'),
          self.OnOK,
          (),
          81], [localization.GetByLabel('UI/Generic/Cancel'),
          self.OnCancel,
          (),
          81]])
        self.sr.main.children.insert(0, self.sr.standardBtns)
        self.sr.txtWarning = uicontrols.EveLabelMedium(parent=self.sr.main, align=uiconst.TOBOTTOM, top=0, padding=4, color=[1,
         0,
         0,
         1], state=uiconst.UI_HIDDEN)
        self.sr.scroll = uicontrols.Scroll(parent=self.sr.main, padding=const.defaultPadding)
        self.sr.scroll.multiSelect = False
        self.sr.scroll.OnSelectionChange = self.OnScrollSelectionChange
        self.label = uicontrols.EveLabelSmall(text=localization.GetByLabel('UI/Shared/TypeSearchString'), parent=self.sr.topParent, left=70, top=5, state=uiconst.UI_NORMAL)
        inpt = self.sr.inpt = uicontrols.SinglelineEdit(name='edit', parent=self.sr.topParent, left=70, top=self.label.top + self.label.height + 2, width=86, align=uiconst.TOPLEFT, maxLength=32, setvalue=self.searchAttr)
        inpt.OnReturn = self.Search
        btn = uicontrols.Button(parent=self.sr.topParent, label=localization.GetByLabel('UI/Corporations/CorporationWindow/Standings/Search'), pos=(inpt.left + inpt.width + 2,
         inpt.top,
         0,
         0), func=self.Search, btn_default=1)
        self.sr.exactChkBox = uicontrols.Checkbox(text=localization.GetByLabel('UI/Corporations/CorporationWindow/Standings/SearchExact'), parent=self.sr.topParent, configName='SearchExactChk', retval=1, align=uiconst.TOPLEFT, pos=(inpt.left,
         inpt.top + inpt.height,
         200,
         0))
        self.SetTopparentHeight(max(52, self.sr.exactChkBox.top + self.sr.exactChkBox.height))
        if self.searchAttr:
            self.Search()
        return self

    def Search(self, *args):
        scrolllist = []
        self.ShowLoad()
        self.sr.txtWarning.state = uiconst.UI_HIDDEN
        try:
            groupID, exact = const.groupCorporation, self.sr.exactChkBox.GetValue()
            self.searchStr = self.GetSearchStr()
            self.SetHint()
            if len(self.searchStr) < 1:
                self.SetHint(localization.GetByLabel('UI/Shared/PleaseTypeSomething'))
                return
            result = sm.RemoteSvc('lookupSvc').LookupCorporationsOrAlliances(self.searchStr, exact, self.warableEntitysOnly)
            if result is None or not len(result):
                if exact:
                    self.SetHint(localization.GetByLabel('UI/Corporations/CorporationWindow/Standings/ExactCorpOrAllianceNameNotFound', searchString=self.searchStr))
                else:
                    self.SetHint(localization.GetByLabel('UI/Corporations/CorporationWindow/Standings/CorpOrAllianceNameNotFound', searchString=self.searchStr))
                return
            cfg.eveowners.Prime([ each.ownerID for each in result ])
            for each in result:
                owner = cfg.eveowners.Get(each.ownerID)
                scrolllist.append(listentry.Get('Item', {'label': owner.ownerName,
                 'OnDblClick': self.OnOK,
                 'typeID': owner.typeID,
                 'itemID': each.ownerID,
                 'confirmOnDblClick': 1,
                 'listvalue': [owner.ownerName, each.ownerID]}))

        finally:
            self.sr.scroll.Load(fixedEntryHeight=18, contentList=scrolllist)
            self.HideLoad()

    def GetSearchStr(self):
        if self.searchAttr and self.sr.inpt.GetValue() == '':
            return self.searchAttr
        return self.sr.inpt.GetValue().strip()

    def Confirm(self):
        self.OnOK()

    def ValidateOK(self):
        if self.searchStr != self.GetSearchStr():
            self.Search()
            return 0
        log.LogInfo('ValidateOK')
        if self.ownerID is None:
            return 0
        return 1

    def SetHint(self, hintstr = None):
        if hintstr is not None:
            self.sr.txtWarning.text = hintstr
            self.sr.txtWarning.state = uiconst.UI_DISABLED
        else:
            self.sr.txtWarning.state = uiconst.UI_HIDDEN

    def HideHint(self):
        self.sr.txtWarning.state = uiconst.UI_HIDDEN

    def OnScrollSelectionChange(self, *args):
        self.HideHint()

    def OnOK(self, *args):
        sel = self.sr.scroll.GetSelected()
        if sel:
            self.ownerID = sel[0].itemID
            self.CloseByUser()
        else:
            self.SetHint(localization.GetByLabel('UI/Corporations/CorporationWindow/Standings/ErrorPleaseChoose'))

    def OnCancel(self, *args):
        self.ownerID = None
        self.CloseByUser()
