#Embedded file name: e:\jenkins\workspace\client_SERENITY\branches\release\SERENITY\packages\projectdiscovery\client\projects\subcellular\info.py
INFO = {'projectId': 17,
 'name': 'Human Protein Atlas - Subcell Atlas - Finding reference patterns in sample image - Test project',
 'resultSchema': {'type': 'array',
                  'items': {'type': 'integer',
                            'enum': [101,
                                     102,
                                     111,
                                     112,
                                     113,
                                     121,
                                     122,
                                     123,
                                     131,
                                     201,
                                     202,
                                     203,
                                     211,
                                     212,
                                     213,
                                     214,
                                     215,
                                     221,
                                     222,
                                     231,
                                     232,
                                     233,
                                     301,
                                     302,
                                     303,
                                     901,
                                     902]},
                  'minItems': 1,
                  'maxItems': 10,
                  'uniqueItems': True},
 'resultExamples': [[10, 15, 25], [1], []],
 'assetsSchema': {'type': 'object',
                  'properties': {'urls': {'type': 'object',
                                          'properties': {'channelYellow': {'description': 'The URL of the image to be analysed (channel: yellow)',
                                                                           'type': 'string'},
                                                         'channelRed': {'description': 'The URL of the image to be analysed (channel: red)',
                                                                        'type': 'string'},
                                                         'channelGreen': {'description': 'The URL of the image to be analysed (channel: green)',
                                                                          'type': 'string'},
                                                         'channelBlue': {'description': 'The URL of the image to be analysed (channel: blue)',
                                                                         'type': 'string'},
                                                         'channelRedGreen': {'description': 'The URL of the image to be analysed (channel: red+green)',
                                                                             'type': 'string'},
                                                         'channelBlueRedGreen': {'description': 'The URL of the image to be analysed (channel: blue+red+green)',
                                                                                 'type': 'string'}}}}},
 'info': {'baseUrl': 'http://d31li3s7awgent.cloudfront.net/',
          'classes': [{'id': 1,
                       'parentId': None,
                       'name': 'Nucleus',
                       'description': 'The nucleus takes up a big part of the cell volume, and looks like a big, round ball, overlapping with the blue marker. Sometimes though, only small structures are stained within the nucleus.'},
                      {'id': 10,
                       'parentId': 1,
                       'name': 'Nucleus',
                       'description': 'The nucleus takes up a big part of the cell volume, and looks like a big, round ball, overlapping with the blue marker. Sometimes though, only small structures are stained within the nucleus.'},
                      {'id': 101,
                       'parentId': 10,
                       'name': 'Nucleus',
                       'description': 'The nucleus takes up a big part of the cell volume, and looks like a big, round ball. The nucleus contains the DNA, which encodes genetic information.',
                       'descriptionIdentification': 'The nucleus takes up a big part of the cell volume, and looks like a big, round ball. It overlaps with the blue marker and is evenly stained.',
                       'descriptionScientific': 'The spherical nucleus takes up a big part of the cell volume. It contains the DNA, which encodes genetic information. The nucleus also contains all the proteins needed for maintaining and repairing the DNA structure as well as regulating its expression.',
                       'url': '101_hpa_subcell_task1_ref_HPA047549_nucleus.jpg',
                       'excludes': [102]},
                      {'id': 102,
                       'parentId': 10,
                       'name': 'Nucleoplasm',
                       'description': 'The nucleoplasm encompasses everything in the nucleus except the nucleoli.',
                       'descriptionIdentification': 'The nucleoplasm encompasses everything in the nucleus except the nucleoli (a few small, elongates circles) and overlaps with the blue marker.',
                       'descriptionScientific': 'The spherical nucleus takes up a big part of the cell volume. It contains the DNA, which encodes genetic information. The nucleus also contains all the proteins needed for maintaining and repairing the DNA structure as well as regulating its expression.',
                       'url': '102_hpa_subcell_task1_ref_HPA029693_nucleoplasm.jpg',
                       'excludes': [101, 12]},
                      {'id': 11,
                       'parentId': 1,
                       'name': 'Nuclear bodies and speckles',
                       'description': 'Nuclear pattern where not all of the nucleus is stained but only small structures within it.'},
                      {'id': 111,
                       'parentId': 11,
                       'name': 'Nuclear bodies (few)',
                       'description': 'Nuclear bodies are uneven structures found in the nucleus. It is a collective term for structures with different (often unknown) functions but similar staining pattern.',
                       'descriptionIdentification': 'A few (five or less) distinct spots in the nucleus (blue marker) are stained.',
                       'descriptionScientific': 'Nuclear bodies is a collective term for structures with different functions but similar staining pattern found in the nucleus. They are smaller and their shape is more spherical compared to nuclear speckles. Distinct spotty staining patterns might be structures that help organizing the DNA, repairs DNA or pre-processing RNA.',
                       'url': '111_hpa_subcell_task1_ref_HPA036081_nuclear_bodies_few.jpg',
                       'excludes': [112]},
                      {'id': 112,
                       'parentId': 11,
                       'name': 'Nuclear bodies (many)',
                       'description': 'Nuclear bodies are uneven structures found in the nucleus. It is a collective term for structures with different (often unknown) functions but similar staining pattern.',
                       'descriptionIdentification': 'A high number (more than five) of distinct spots in the nucleus (blue marker) are stained.',
                       'descriptionScientific': 'Nuclear bodies is a collective term for structures with different functions but similar staining pattern found in the nucleus. They are smaller and their shape is more spherical compared to nuclear speckles. Distinct spotty staining patterns might be structures that help organizing the DNA, repairs DNA or pre-processing RNA.',
                       'url': '112_hpa_subcell_task1_ref_CAB010194_nuclear_bodies_many.jpg',
                       'excludes': [111]},
                      {'id': 113,
                       'parentId': 11,
                       'name': 'Nuclear speckles',
                       'description': 'A common pattern is a \xe2\x80\x9dspeckled\xe2\x80\x9d nuclear staining (like leopard speckles). They are distributed evenly throughout the nucleus (usually around 25-50 per cell). Speckles are also organizing the DNA.',
                       'descriptionIdentification': 'Evenly distributed (usually around 20-40 per cell) throughout the nucleus (blue marker) and with their uneven shape they look somewhat like leopard speckles.',
                       'descriptionScientific': 'A common pattern is a speckled nuclear staining (like leopard speckles). Speckles consist of smaller subunits that are involved in organizing the DNA and its expression.',
                       'url': '113_hpa_subcell_task1_ref_HPA002031_nuclear_speckles.jpg',
                       'excludes': []},
                      {'id': 12,
                       'parentId': 1,
                       'name': 'Nucleoli',
                       'description': 'Nucleoli are usually stained as small, somewhat elongated circles in the nucleus. However, their staining pattern can vary from the nucleolus being completely stained, to only a small part of it, sometimes in a spotty pattern. It is common that proteins are localized to both the nucleus and the nucleoli, with different staining intensity, as well as only the nucleoli. The nucleoli take part in several different processes in the cell, and produce part of the endoplasmic reticulum.'},
                      {'id': 121,
                       'parentId': 12,
                       'name': 'Nucleoli',
                       'description': 'Nucleoli are usually stained as small, somewhat elongated circles in the nucleus. However, their staining pattern can vary from the nucleolus being completely stained, to only a small part of it, sometimes in a spotty pattern. It is common that proteins are localized to both the nucleus and the nucleoli, with different staining intensity, as well as only the nucleoli. The nucleoli take part in several different processes in the cell, and produce part of the endoplasmic reticulum.',
                       'descriptionIdentification': 'A few small, somewhat elongated circles within the nucleus (blue marker), overlapping with holes in the blue marker.',
                       'descriptionScientific': 'The staining pattern of nucleoli can vary from the nucleolus being completely stained, to only a small part of it, sometimes in a spotty pattern.\xc2\xa0It is common that proteins are localized to both the nucleus and the nucleoli, with different staining intensity, as well as only the nucleoli. The nucleoli take part in several different processes in the cell, and produce ribosomes, the protein synthezisers of the cell.',
                       'url': '121_hpa_subcell_task1_ref_HPA037389_nucleoli.jpg',
                       'excludes': [102]},
                      {'id': 122,
                       'parentId': 12,
                       'name': 'Nucleoli (rim)',
                       'description': 'The edge of the nucleoli is stained stronger than the rest of the nucleoli.',
                       'descriptionIdentification': 'A clear staining of the edge of the nucleoli, which are small, somewhat elongated circles within the nucleus (blue marker), overlapping with holes in the blue marker.',
                       'descriptionScientific': 'The staining pattern of nucleoli can vary from the nucleolus being completely stained, to only a small part of it, sometimes in a spotty pattern.\xc2\xa0It is common that proteins are localized to both the nucleus and the nucleoli, with different staining intensity, as well as only the nucleoli. The nucleoli take part in several different processes in the cell, and produce ribosomes, the protein synthezisers of the cell.',
                       'url': '122_hpa_subcell_task1_ref_HPA026512_nucleoli_rim.jpg',
                       'excludes': [102]},
                      {'id': 123,
                       'parentId': 12,
                       'name': 'Nucleoli (fibrillar center)',
                       'description': 'Clusters of small spots in the nucleoli.',
                       'descriptionIdentification': 'Clusters of small spots in the nucleoli, which are small, somewhat elongated circles within the nucleus, overlapping with holes in the blue marker.',
                       'descriptionScientific': 'The staining pattern of nucleoli can vary from the nucleolus being completely stained, to only a small part of it, sometimes in a spotty pattern.\xc2\xa0It is common that proteins are localized to both the nucleus and the nucleoli, with different staining intensity, as well as only the nucleoli. The nucleoli take part in several different processes in the cell, and produce ribosomes, the protein synthezisers of the cell.',
                       'url': '123_hpa_subcell_task1_ref_HPA006385_nucleoli_fibrillar_center.jpg',
                       'excludes': [102]},
                      {'id': 13,
                       'parentId': 1,
                       'name': 'Nuclear membrane',
                       'description': 'The nuclear membrane is easy to recognize, the staining forming a thin circle around the nucleus. It is sometimes also possible to see the the many folds of the nuclear membrane. Its purpose is to keep the nucleus and cytoplasm separated, so the DNA in the nucleus stays in one place.'},
                      {'id': 131,
                       'parentId': 13,
                       'name': 'Nuclear membrane',
                       'description': 'The nuclear membrane is easy to recognize, the staining forming a thin circle around the nucleus. It is sometimes also possible to see the the many folds of the nuclear membrane. Its purpose is to keep the nucleus and cytoplasm separated, so the DNA in the nucleus stays in one place.',
                       'descriptionIdentification': 'The nuclear membrane is easy to recognize, the staining forming a thin circle around the nucleus (blue marker). It is sometimes also possible to see the the many folds of the nuclear membrane.',
                       'descriptionScientific': 'The purpose of the nuclear membrane is to keep the nucleus and cytoplasm separated, keeping the DNA contained in the nucleus. It also regulates the transport of proteins and other molecules in and out of the nucleus.',
                       'url': '131_hpa_subcell_task1_ref_HPA024023_nuclear_membrane.jpg',
                       'excludes': []},
                      {'id': 2,
                       'parentId': None,
                       'name': 'Cytoplasm',
                       'description': 'The cytoplasm encompasses the whole cell except for the nucleus (blue marker). There are several different structures located within the cytoplasm.'},
                      {'id': 20,
                       'parentId': 2,
                       'name': 'Cytoplasm, aggresome and mitochondria',
                       'description': 'The cytoplasm is the encompasses the whole cell except for the nucleus. The aggresome and the mitochondria are two different organelles within the cytoplasm with very specific functions. They are also easy to recognize most of the time with their specific patterns.'},
                      {'id': 201,
                       'parentId': 20,
                       'name': 'Cytoplasm',
                       'description': 'The immunofluorescent staining of the cytoplasm encompasses the whole cell except for the nucleus. The staining can vary in intensity throughout the cell, and is often stronger close to the nucleus. The cytoplasm is a very heterogeneous mixture of different proteins.',
                       'descriptionIdentification': 'Is seen throughout the whole cell, except in the nucleus (blue marker). The intensity can vary throughout the cell, and is often stronger close to the nucleus.',
                       'descriptionScientific': 'The cytoplasm is a very heterogenous mixture of different proteins.',
                       'url': '201_hpa_subcell_task1_ref_HPA002383_cytoplasm.jpg',
                       'excludes': []},
                      {'id': 202,
                       'parentId': 20,
                       'name': 'Aggresome',
                       'description': 'The aggresome can be seen as a very dense, oval ball next to the nucleus. It overlaps with a hole in the microtubules. The aggresome contains proteins that are misfolded, which should be sent for destruction.',
                       'descriptionIdentification': 'The aggresome can be seen as a very dense, oval ball next to the nucleus (blue marker). It overlaps with a hole in the microtubules (red marker).',
                       'descriptionScientific': 'The aggresome contains proteins that are misfolded and will be sent for destruction.',
                       'url': '202_hpa_subcell_task1_ref_HPA053693_aggresome.jpg',
                       'excludes': []},
                      {'id': 203,
                       'parentId': 20,
                       'name': 'Mitochondria',
                       'description': 'Mitochondrial stainings are most often easy to recognize as they have a long, thread like pattern, rather like spaghetti (sometimes long, and sometimes chopped up). They are spread throughout the cell, starting centrally, close to the nucleus and stretch all the way out to the edges of the cell. The mitochondria are responsible for supplying the cell with energy.',
                       'descriptionIdentification': 'A long, thread like pattern, rather like spaghetti (sometimes long and sometimes chopped up). The mitochondria can be found throughout the cell, starting centrally, close to the nucleus and stretch all the way out to the edges of the cell.',
                       'descriptionScientific': 'The mitochondria are responsible for supplying the cell with energy by conversion of nutrients into ATP. It is also involved in signalling and regulating cell death.',
                       'url': '203_hpa_subcell_task1_ref_HPA001523_mitochondria.jpg',
                       'excludes': []},
                      {'id': 21,
                       'parentId': 2,
                       'name': 'Cytoskeleton',
                       'description': "The cytoskeleton is a network of fibers with a multitude of functions. It gives the cell it's shape, is involved in cell motility, intracellular transport and cell division."},
                      {'id': 211,
                       'parentId': 21,
                       'name': 'Cytoskeleton (intermediate filaments)',
                       'description': 'Intermediate filaments often have a tangled, rope-like structure that supports the cell structure. Those are often seen throughout the cell, whereas others, enclosing the nuclei, have a more condensed look. The role of intermediate filaments is to provide a mechanic support to the cell.',
                       'descriptionIdentification': 'Often seen as tangled, rope-like structure throughout the cell. Some are smaller and enclose the nucleus (blue marker), and have a more condensed look.',
                       'descriptionScientific': 'The role of intermediate filaments is to provide the cell with mechanical support. Some are in direct connection with the nuclear membrane, supporting it and anchoring the DNA to it.',
                       'url': '211_hpa_subcell_task1_ref_HPA040676_cytoskeleton_intermediate_filaments.jpg',
                       'excludes': []},
                      {'id': 212,
                       'parentId': 21,
                       'name': 'Cytoskeleton (microtubule ends)',
                       'description': 'The microtubules grow by adding new fragments to the \xe2\x80\x9dplus ends\xe2\x80\x9d, which are the tips of the microtubules, furthest away from the nucleus. Sometimes only one end is stained and not the rest of the microtubule.',
                       'descriptionIdentification': 'Short strands at the tip or the center of the microtubules (red marker), overlapping perfectly with it. Sometimes only the ends are stained and not the rest of the microtubules.',
                       'descriptionScientific': "The microtubules grow by adding new fragments to the 'plus ends', which are the tips of the microtubules, furthest away from the nucleus.",
                       'url': '212_hpa_subcell_task1_ref_HPA026678_cytoskeleton_microtubule_ends.jpg',
                       'excludes': []},
                      {'id': 213,
                       'parentId': 21,
                       'name': 'Cytoskeleton (microtubules)',
                       'description': 'Staining of microtubules shows thin strands that stretch throughout the whole cell. It is almost always possible to detect the center from which they all originate, the centrosome, even though it need not be stained. The purpose of the microtubules is to act as a railway for transports around the cell.',
                       'descriptionIdentification': 'Thin strands stretching throughout the cell. Overlaps perfectly with the red marker making the color turn yellow.',
                       'descriptionScientific': 'Staining of microtubules shows thin strands that stretch throughout the whole cell. It is almost always possible to detect the center from which they all originate, the centrosome, even though it need not be stained.\xc2\xa0The purpose of the microtubules is to act as a railway for transports around the cell, and separate duplicated DNA in cell division.',
                       'url': '213_hpa_subcell_task1_ref_HPA002647_cytoskeleton_microtubules.jpg',
                       'excludes': []},
                      {'id': 214,
                       'parentId': 21,
                       'name': 'Cytoskeleton (actin filaments)',
                       'description': 'Actin filaments are easy to recognize as they are often localized close to the plasma membrane, outlining the edges of the cell. They can usually be seen as long, very straight and parallel filaments and help hold up the membrane.',
                       'descriptionIdentification': 'Long, very straight and parallel filaments that outline the edges of the cell.',
                       'descriptionScientific': 'Actin filaments are easy to recognize as they are often localized close to the plasma membrane, outlining the edges of the cell. They can usually be seen as long, very straight and parallel filaments and help the membrane keeping its shape. It is also involved in cell motility.',
                       'url': '214_hpa_subcell_task1_ref_HPA043746_cytoskeleton_actin_filaments.jpg',
                       'excludes': []},
                      {'id': 215,
                       'parentId': 21,
                       'name': 'Cytoskeleton (cytokinetic bridge)',
                       'description': 'The cytokinetic bridge is a small structure present during the last stage of cell division, and can only be seen at the tip between two cells that have almost been separated and moved apart. It acts as a scissor, which cuts the bond between the two cells.',
                       'descriptionIdentification': 'A small structure that can only be seen at the tip between two cells that have almost been separated and moved apart, next to condensed microtubules (red marker).',
                       'descriptionScientific': 'The cytokinetic bridge is a small structure present during the last stage of cell division, and can only be seen at the tip between two dividing cells that have almost been separated and moved apart. It acts as a scissor, which cuts the bond between the two cells.',
                       'url': '215_hpa_subcell_task1_ref_HPA028258_cytoskeleton_cytokinetic_bridge.jpg',
                       'excludes': []},
                      {'id': 22,
                       'parentId': 2,
                       'name': 'Center of microtubules',
                       'description': 'The microtubule organizing center and centrosome is found at the center of the microtubules.'},
                      {'id': 221,
                       'parentId': 22,
                       'name': 'Microtubule organizing center',
                       'description': 'The centrosome/MTOC always overlaps with the center of the microtubules, making it easy to find next to the nucleus. Stainings of single or double spots at the origin of microtubules are annotated as centrosome whereas larger structures stained at that location are annotated as MTOC (microtubule organizing center). The centrosome helps the cell to divide.',
                       'descriptionIdentification': 'A small and somewhat diffuse structure that overlaps with the center of the microtubules (red marker), next to the nucleus (blue marker).',
                       'descriptionScientific': 'The MTOC (microtubule organizing center) always overlaps with the center of the microtubules, making it easy to find next to the nucleus. Staining of single or double spots at the origin of microtubules are annotated as centrosomes whereas larger structures centered at that location are annotated as MTOC. The centrosome helps the cell to divide.',
                       'url': '221_hpa_subcell_task1_ref_HPA050499_microtubule_organizing_center.jpg',
                       'excludes': [222]},
                      {'id': 222,
                       'parentId': 22,
                       'name': 'Centrosome',
                       'description': 'The centrosome/MTOC always overlaps with the center of the microtubules, making it easy to find next to the nucleus. Stainings of single or double spots at the origin of microtubules are annotated as centrosome whereas larger structures stained at that location are annotated as MTOC (microtubule organizing center). The centrosome helps the cell to divide.',
                       'descriptionIdentification': 'Single or double spots which overlaps with the center of the microtubules (red marker), next to the nucleus (blue marker).',
                       'descriptionScientific': 'The centrosome always overlaps with the center of the microtubules, making it easy to find next to the nucleus. Staining of single or double spots at the origin of microtubules are annotated as centrosomes whereas larger structures centered at that location are annotated as MTOC (microtubule organizing center). The centrosome helps the cell to divide.',
                       'url': '222_hpa_subcell_task1_ref_HPA043212_centrosome.jpg',
                       'excludes': [221]},
                      {'id': 23,
                       'parentId': 2,
                       'name': 'Secretory organelles',
                       'description': 'These organells form, together with the plasma membrane, the secretory pathway in the cell. These steps forms the basis for secretion, which is a way for the cell to move proteins out of itself'},
                      {'id': 231,
                       'parentId': 23,
                       'name': 'Endoplasmic reticulum',
                       'description': 'The endoplasmic reticulum is a network stretching throughout the cytoplasm. It\xe2\x80\x99s structure can be likened to a spider web and it\xe2\x80\x99s a hub where proteins are stored and sometimes modified before sent along to the Golgi apparatus.',
                       'descriptionIdentification': "A symmetrical structure found throughout the cell (excluded from the blue marker). It is a mesh like network that looks somewhat like a spider's web.",
                       'descriptionScientific': 'The endoplasmic reticulum is a symmetrical network stretching throughout the cytoplasm. Its structure can be likened to a spider\xe2\x80\x99s web and it\xe2\x80\x99s a hub where proteins are stored and sometimes modified before sent along to the Golgi apparatus for further modification.',
                       'url': '231_hpa_subcell_task1_ref_HPA012542_endoplasmic_reticulum.jpg',
                       'excludes': []},
                      {'id': 232,
                       'parentId': 23,
                       'name': 'the Golgi apparatus',
                       'description': 'The Golgi apparatus is located next to the nucleus, sometimes growing around it. It often looks like collection of small particles. The Golgi handles incoming proteins from the endoplasmic reticulum, modifies them and then sends them off to their final destinations within the cell.',
                       'descriptionIdentification': 'The Golgi apparatus is located next to the nucleus, sometimes lying around or above it. It often looks like collection of small, dense particles that may be donut shaped.',
                       'descriptionScientific': 'The Golgi handles incoming proteins from the endoplasmic reticulum, modifies them and then sends them off to their final destinations within the cell.',
                       'url': '232_hpa_subcell_task1_ref_HPA008395_the_Golgi_appratus.jpg',
                       'excludes': []},
                      {'id': 233,
                       'parentId': 23,
                       'name': 'Vesicles',
                       'description': 'Vesicles can be seen as small, bright dots that are uniform in size and shape. They are either distributed evenly throughout the cell, or clustering next to the nucleus. Vesicles are responsible for moving things (cargo) around in the cell.',
                       'descriptionIdentification': 'Small, bright dots that are uniform in size and shape. They are either evenly distributed  throughout the cell, or clustering next to the nucleus (blue marker) but never in the nucleus.',
                       'descriptionScientific': 'Several different types of vesicles exist, some are responsible for moving cargo in the cell, others are degrading proteins and some work with transporting and subsequently releasing signal substances from the cell\xe2\x80\x99s membrane.',
                       'url': '233_hpa_subcell_task1_ref_HPA002078_vesicles.jpg',
                       'excludes': []},
                      {'id': 3,
                       'parentId': None,
                       'name': 'Periphery',
                       'description': 'These structures are part of the outer edges of the cell.'},
                      {'id': 30,
                       'parentId': 3,
                       'name': 'Periphery',
                       'description': 'These structures are part of the outer edges of the cell.'},
                      {'id': 301,
                       'parentId': 30,
                       'name': 'Cell junctions',
                       'description': 'Staining of cell junctions can only be observed when the cells are in contact. The staining is very specific, and is only seen at the actual site of cell-cell connections. Cell junctions are important for cell-cell communication.',
                       'descriptionIdentification': 'Can only be observed when the cells are in contact, at the actual site of cell-cell connections.',
                       'descriptionScientific': 'Staining of cell junctions can only be observed when the cells are in contact. The staining is very specific, and is only seen at the actual site of cell-cell connections. Cell junctions are important for cell-cell communication.',
                       'url': '301_hpa_subcell_task1_ref_HPA036958_cell_junctions.jpg',
                       'excludes': []},
                      {'id': 302,
                       'parentId': 30,
                       'name': 'Focal adhesions',
                       'description': 'Focal adhesions are localized just outside the cell membrane and can thus be found either just under the cell or at the edge of the cell membrane, where the cell is attached to the surface. They are the feet of the cell, and is what the cell uses to move across a surface in response to signals.',
                       'descriptionIdentification': 'Localized under the cell or at the edge of the cell membrane, where the cell is attached to the surface.',
                       'descriptionScientific': 'Focal adhesions keep the cells attached to the surface by acting as linkers between actin filaments and the surface. They are used by the cell to move across a surface in response to signals.',
                       'url': '302_hpa_subcell_task1_ref_HPA055338_focal_adhesions.jpg',
                       'excludes': []},
                      {'id': 303,
                       'parentId': 30,
                       'name': 'Plasma membrane',
                       'description': 'The cell membrane - or the plasma membrane - encloses the cell and acts as a border towards the environment. Staining of the cell membrane can appear differently, sometimes the staining only appear as a rim around the cell, sometimes protrusions are extending from it and sometimes it may appear as a uniform and very flat staining across the entire cell.',
                       'descriptionIdentification': 'It may appear as a uniform and very flat staining across the entire cell, and can usually be seen clearly outside the red marker. Sometimes only appears as a rim around the cell, and sometimes protrusions are extending from it.',
                       'descriptionScientific': 'The cell membrane - or the plasma membrane - encloses the cell and acts as a border towards the environment. It regulates transports in and out of the cell of substances such as signal molecules and nutrients.',
                       'url': '303_hpa_subcell_task1_ref_HPA029159_plasma_membrane.jpg',
                       'excludes': []},
                      {'id': 9,
                       'parentId': None,
                       'name': 'Not identifiable',
                       'description': 'Negative or unspecific staining'},
                      {'id': 90,
                       'parentId': 9,
                       'name': 'Not identifiable',
                       'description': 'Negative or unspecific staining'},
                      {'id': 901,
                       'parentId': 90,
                       'name': 'Negative',
                       'description': 'No or extremely weak green staining is seen in the image.',
                       'url': '901_hpa_subcell_task1_ref_HPA055108_negative.jpg',
                       'excludes': '*'},
                      {'id': 902,
                       'parentId': 90,
                       'name': 'Unspecific',
                       'description': 'No distinguishing patterns can be identified from the staining. All parts of the cells are stained uniformly or staining artifacts are seen outside the cells.',
                       'url': '902_hpa_subcell_task1_ref_HPA034636_unspecific.jpg',
                       'excludes': '*'}]},
 'infoSchema': {'type': 'object',
                'properties': {'baseUrl': {'description': 'The base url to add to the class urls',
                                           'type': 'string'},
                               'classes': {'type': 'array',
                                           'items': {'type': 'object',
                                                     'properties': {'id': {'description': 'The id of the class',
                                                                           'type': 'string'},
                                                                    'parentId': {'description': 'The id of the containing class',
                                                                                 'type': 'string'},
                                                                    'name': {'description': 'The name of the class',
                                                                             'type': 'string'},
                                                                    'description': {'description': 'The description of the class',
                                                                                    'type': 'string'},
                                                                    'url': {'description': 'The URL of the reference image',
                                                                            'type': 'string'},
                                                                    'excludes': {'oneOf': [{'type': 'array',
                                                                                            'items': {'description': "The id of the class that can't be selected in case of the class is selected.",
                                                                                                      'type': 'integer'}}, {'description': "The string '*' marks that all other classes are excluded",
                                                                                            'type': 'string'}]}}}}}}}
